<template lang="pug">

  .container(v-loading="pageLoading")
    .block-typical
      el-form.flex-form(
        ref='vacancyForm'
        v-if="inputs.length"
        :model='stateForm'
        :rules="rules")

        el-form-item(
          v-for="item in inputs"
          :key="item.id"
          :style="vacancyFormStyle(item)"
          :prop="item.name")
          app-input(
            :placeholder="item.placeholder"
            :model="stateForm[item.name]"
            :name="item.name"
            :id="item.id"
            :label="item.label"
            :type="item.type"
            :prompt="item.prompt"
            :autosize="item.autosize"
            :required="item.required"
            :maxlength="item.maxlength"
            @input-value="modelValue")

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
          v-model='vacancyActive'
          active-color="#39D24E"
          :active-value='true'
          :inactive-value='false')


    .activity__block
      router-link.el-button.el-button--info.button(
        :to="{path: '/admin/vacancies'}")
        |Отмена

      el-button.button(
        type="success"
        @click="createVacancy('vacancyForm')")
        |Создать вакансию

</template>

<script>
import InputItem from '../../../components/InputItem';

export default {
  layout: 'admin',
  name: 'NewVacancy',
  components: {
    'app-input': InputItem
  },
  data() {
    return {
      inputs: [
        {
          id: 0,
          placeholder: 'Укажите наименование вакансии',
          model: '',
          label: 'Наименование вакансии',
          name: 'name',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 1,
          placeholder: 'Укажите наименование вакансии',
          model: '',
          label: 'Географическое положение',
          name: 'city',
          prompt: 'Например: Кострома, АО "Шувалово"'
        },
        {
          id: 2,
          placeholder: 'Укажите описание новости',
          model: '',
          label: 'Описание новости',
          name: 'description',
          type: 'editor',
          required: true,
          minWidth: '100%',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 3,
          placeholder: '',
          model: '',
          label: 'Cортировка',
          name: 'sort',
          type: 'sort',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите параметры сортировки',
              trigger: 'change'
            }
          ]
        }
      ],
      pageLoading: false,
      vacancyActive: false
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = item.model;
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Вакансии',
        slug: '/admin/vacancies'
      }
    ]);
    this.$store.commit('headingTitle', 'Cоздание вакансии');
    this.$store.commit('publicLink', '');
    this.$store.commit('id', '');
  },
  methods: {
    vacancyFormStyle(item) {
      let style = {};
      if (item.maxWidth) {
        style['max-width'] = item.maxWidth;
      }
      if (item.minWidth) {
        style['min-width'] = item.minWidth;
      }
      style['margin-bottom'] = '35px';
      return style;
    },
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.inputs[index].model = valueArr[1];
    },
    createVacancy(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          this.$axios
            .post('/api/v1/vacancies/', {
              name: this.stateForm.name,
              description: this.stateForm.description,
              city: this.stateForm.city,
              sort: this.stateForm.sort,
              active: this.vacancyActive
            })
            .then(
              data => {
                this.pageLoading = false;
                this.$router.push('/admin/vacancies');
                this.$message.success('Вакансия успешно создана!');
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error('Ошибка перезаписи данных!');
                this.pageLoading = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка перезаписи данных');
              this.pageLoading = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
